<?php 
/**
 * Estadísticas casillas - estadisticas_casillas_3.php
 * 
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2011 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2011-06-03
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">\n"; 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <title>Estadísticas de casillas (Resultado). Exámenes.  
  PHP. Bartolomé Sintes Marco</title>
  <link href="mclibre_php_soluciones.css" rel="stylesheet" type="text/css" 
  title="Color" />
</head>
<body>

<h1>Estadísticas de casillas (Resultado)</h1>
<?php
function recoge($var)
{ 
    $tmp = (isset($_REQUEST[$var])) ? strip_tags(trim(htmlspecialchars($_REQUEST[$var]))) : '';
    if (get_magic_quotes_gpc()) {
        $tmp = stripslashes($tmp);
    }
    return $tmp;
}

function recogeMatriz2($var) 
{
    $tmpMatriz = array();
    if (isset($_REQUEST[$var]) && is_array($_REQUEST[$var])) {
        foreach ($_REQUEST[$var] as $indice => $fila) {
            $tmp = strip_tags(trim(htmlspecialchars($indice)));
            if (get_magic_quotes_gpc()) {
                $tmp = stripslashes($tmp);
            }
            $indiceLimpio = $tmp;
            if (is_array($fila)) {
                foreach ($fila as $indice2 => $valor) {
                    $tmp = strip_tags(trim(htmlspecialchars($indice2)));
                    if (get_magic_quotes_gpc()) {
                        $tmp = stripslashes($tmp);
                    }
                    $indice2Limpio = $tmp;

                    $tmp = strip_tags(trim(htmlspecialchars($valor)));
                    if (get_magic_quotes_gpc()) {
                        $tmp = stripslashes($tmp);
                    }
                    $valorLimpio  = $tmp;

                    $tmpMatriz[$indiceLimpio][$indice2Limpio] = $valorLimpio;
                }                      
            }
        }
    }
    return $tmpMatriz;
}

$casillas      = recogeMatriz2('c');
$filas    = recoge('filas');
$columnas = recoge('columnas');
$filasMinimo = $columnasMinimo = 5;
$filasMaximo = $columnasMaximo = 15;
$filasOk = $columnasOk = FALSE;
$maximo = 'N';
$maximoX = $maximoY = -1;

$casillasMarcadas = 0;
foreach ($casillas as $indice => $valor) {
    foreach ($valor as $indice2 => $valor2) {
        if ($valor2 != '') {
            $casillasMarcadas++;
        }
    }
}

if ($filas=="") {
    print "<p style=\"color: red\">No ha escrito el número de filas.</p>\n";
} elseif (!ctype_digit($filas)) { 
    print "<p style=\"color: red\">No ha escrito el número de filas "
        ."como número entero positivo.</p>\n";
} elseif ($filas<$filasMinimo || $filas>$filasMaximo) {
    print "<p style=\"color: red\">El número de filas debe estar entre "
    	."$filasMinimo y $filasMaximo.</p>\n";
} else {
    $filasOk = TRUE;
}

if ($columnas=="") {
    print "<p style=\"color: red\">No ha escrito el número de columnas.</p>\n";
} elseif (!ctype_digit($columnas)) { 
    print "<p style=\"color: red\">No ha escrito el número de columnas "
        ."como número entero positivo.</p>\n";
} elseif ($columnas<$columnasMinimo || $columnas>$columnasMaximo) {
    print "<p style=\"color: red\">El número de columnas debe estar entre "
    	."$columnasMinimo y $columnasMaximo.</p>\n";
} else {
    $columnasOk = TRUE;
}    

if ($casillasMarcadas==0) {
    print "<p>No ha marcado ninguna casilla.</p>";
} else {
    $casillasOk = TRUE;
    foreach ($casillas as $indice => $fila) {
        if (ctype_digit((string)$indice)&&($indice<=$filas)&&is_array($fila)) {
            foreach ($fila as $indice2 => $valor2) {
                // ahora se comprueba que todos los índices son enteros inferiores al máximo
                // y que el valor es on
                if (!ctype_digit((string)$indice2)||($indice2>$columnas)|| (!ctype_digit($valor2) && ($valor2!=''))) {
                    $casillasOk = FALSE;
                }
            }
        } else {
            $casillasOk = FALSE;
        }       
    }
    if (!$casillasOk) {
        print "<p style=\"color:red\">La matriz recibida no es correcta.</p>\n";
    }
    
    if ($filasOk && $columnasOk && $casillasOk) {
		// Valor máximo
		foreach ($casillas as $indice => $valor) {
			foreach ($valor as $indice2 => $valor2) {
				if ($valor2 != "") {
					if ($maximo=='N') { 
						$maximo = $valor2;
						$maximoX = $indice;
						$maximoY = $indice2; 
					} elseif ($maximo < $valor2) {
						$maximo = $valor2; 
						$maximoX = $indice;
						$maximoY = $indice2; 
					}
				}
			}
		}
		print "<p>El número más alto introducido es <span style=\"font-size:200%\">$maximo</span>, escrito en la caja de texto \n"
			."de la fila <span style=\"font-size:200%\">$maximoX</span> y de la columna <span style=\"font-size:200%\">$maximoY</span>.</p>\n";
    }
}
    print "<p><a href=\"estadisticas_casillas_2.php?filas=$filas&amp;columnas=$columnas\">Volver a la tabla</a></p>\n";
    print "<p><a href=\"estadisticas_casillas_1.html\">Volver al formulario inicial.</a></p>\n";
?>

<address>
  Esta página forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de esta página: 3 de junio de 2011 
</address>
<p class="licencia">El programa PHP que genera esta página está bajo 
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</body>
</html>
